-- Notis for RIFT
-- Copyright(C) 2012 Vritra@Wolfsbane. All Rights Reserved.
-- References of the coloration http://jfly.iam.u-tokyo.ac.jp/color/

-- Apprication Variables
local Notis = {UI = {},	Event = {}}
local Info1, Info2 = {}, {}

-- Define
local VER =  "ver 0.3.1a Loaded."

-- local I_RED = {1, 0, 0, 1}	-- Red
local I_RED = {1, .15, 0, 1}	-- 1st Information text color
local I_ORANGE = {1, .6, 0, 1}	-- 2nd Information text color

-- color for Huge-castbar
local AQUA = {0,.6,.9,.7}
local YELLOW = {1,.8,0,.7}
local VIOLET = {.2,0,.1,.7}
local LIME = {0,.3,0,.7}
local CYAN = {.3,.3,1,.7}
local BLACK = {.05,0,.1,1}
local PINK = {1,.75,.8,.4}
local CLEAR = {0,0,0,0}

-- color for small text
local GOLD = {.9,.75,.6,.7}

local DURA = .7
local ELAPSE = 3 + .7
local HUGEDURA = .4
local PULSE = 3
local TIDALWAVE_SEC = 40
local UNHOLYCON_SEC = 12
local WOI_SEC = 25
local UPDATE = .07
local PLAYER = Inspect.Unit.Detail("player").name
local PLAYERID = Inspect.Unit.Lookup("player")
local NOTIFY = {
	{"Look Away",	"Muglak gurgles, \"Look upon my radiance!\""},
	{"Kill Ele",	"Warboss Drak commands, \"Give yourself to the flame and burn for Maelforge!\""},
	{"Right",		"Akylios rears to the right!"},
	{"Left",		"Akylios rears to the left!"},
	{"Center",		"Akylios rears backward!"},
	{"Run Out",		"Grugonim targets * for Rampant Decay!"},
	{"Run Out",		"Grugonim's bile rises!"},
	{"Orb",			"Soulrender Zilas surges with the power of Death!"},
	{"Stack",		"You'll never escape!"},	-- using "/notis stack" test.
	{"Kill Ele",	"Beruhast says, \"A pet from Maelforge should keep you warm.\""},
	{"Kill Add",	"Guurloth screams, \"Say hello to my friend, little ones!\""},
	{"Jump",		"Guurloth screams, \"Jump little fools!\""},
	{"Run",			"Guurloth screams, \"Run little fools!\""},
	{"Look Away",	"Guurloth screams, \"Dare you gaze upon the Orb of Power?\""},
	{"LoS",			"Kaler Andrenos calls on the power from the abyss!"},
	{"LoS",			"Broodmother Venoxas searches for help!"},
	{"Kite",		"Konstantin goes into a fury!", "tank"},
}

function Notis.Pr(str, console, color)
	local TAG ="<font color='#00a8ea'>N</font>"
	TAG = TAG.."<font color='#46bcea'>o</font>"
	TAG = TAG.."<font color='#8cd0ea'>t</font>"
	TAG = TAG.."<font color='#aaffbb'>i</font>"
	TAG = TAG.."<font color='#7fff55'>s</font>"
	TAG = TAG.."<font color='#55ff00'>;</font>"

	str = str or ""
	console = console or "general"
	color = color or "#eaeaea"
	str = TAG.." <font color='"..color.."'>"..str.."</font>"
	Command.Console.Display(console, true, str, true)
end

function Notis.StrToArray(str)
	local t = {}
	local i = 1
	for v in string.gmatch(str, "[^%s]+") do
		t[i] = v
		i = i + 1
	end
	return(t)
end

for j, n in ipairs(NOTIFY) do
	NOTIFY[j][2] = Notis.StrToArray(n[2])
end

table.insert(Event.Addon.SavedVariables.Load.End, {function(addonName)
	if addonName == "Notis" then
		NotisSettings = NotisSettings or {}
		NotisSettings.redBartop = NotisSettings.redBartop or -6
		NotisSettings.hugeBarTop = NotisSettings.hugeBarTop or 100
		NotisSettings.hugeBarHeight = NotisSettings.hugeBarHeight or 52
		NotisSettings.hugeBarAlpha = NotisSettings.hugeBarAlpha or .2
		NotisSettings.x = NotisSettings.x or 120
		NotisSettings.y = NotisSettings.y or 160
		NotisSettings.fontSize = NotisSettings.fontSize or 60

		local now = Inspect.Time.Real()
		Info1 = {duration = 1, begin = now}
		LastUpdate = now + 1
		UIWidth = math.ceil(UIParent:GetWidth()) or 1600
	end
end, "Notis", "LoadValue"})

function Notis.SetNum(value)
	local d, f = math.modf(value)
	d = string.format("%d", d)
	f = string.format(".%02d", f * 99)
	InfoTxt:SetText(d)
	InfoSdw:SetText(d)
	InfoSec:SetText(f)
	InfoScw:SetText(f)
	if value < 1 then
		InfoTxt:SetFontColor(unpack(I_RED))
		InfoSec:SetFontColor(unpack(I_RED))
	else
		InfoTxt:SetFontColor(1, 1, 1, 1)
		InfoSec:SetFontColor(1, 1, 1, 1)
	end
end

function Notis.Activate(val, txt, alpha)
	local now = Inspect.Time.Real()

	if type(val) == "number" then
		InfoFrame.timerMode = true
		Notis.SetNum(val)
		Info1.duration = val
	else
		if StackNumber and val == "Stack" then
			val = "Stack "..tostring(StackNumber)
		end
		Bar1Frame:SetVisible(true)
		Bar2Frame:SetVisible(true)
		InfoFrame.timerMode = false

		if Info1.begin and Info1.duration and Info1.duration + Info1.begin > now + .2 then
			InfoTxt:SetFontColor(unpack(I_ORANGE))
		else
			InfoTxt:SetFontColor(unpack(I_RED))
		end
		val = val or ""
		InfoTxt:SetText(val)
		InfoSdw:SetText(val)
		if val ~= ""  then
			InfoSec:SetFontColor(unpack(I_RED))
		end
		InfoSec:SetText("")
		InfoScw:SetText("")
		Info1.duration = ELAPSE
	end
	if txt then
		local s = ""
		local f = false
		local l = 0
		for v in string.gmatch(txt, "[^%s]+") do
			if s ~= "" then s = s.." " end
			if f then
				s = s.."\n"..v
				f = false
			else
				l = l + v:len()
				if v:len() > 8 then
					s = s.."\n"..v
				else
					s = s..v
					if l > 5 then
						f = true
					end
				end
			end
		end
		txt = s
		if not txt:find("\n") then
			txt = txt.."\n\n"
		end
	else
		txt = ""
	end
	AbiTxt:SetText(txt)
	AbiSdw:SetText(txt)
	Info1.begin = now
	InfoTxt:SetBackgroundColor(0, 0, 0, alpha or 0)
	InfoTxt:SetAlpha(1)
	InfoFrame:SetAlpha(1)
	InfoFrame:SetVisible(true)
end

function Notis.Terminate()
	Info1.duration = nil
	Info1.begin = nil
	InfoFrame:SetVisible(false)
	Bar1Frame:SetVisible(false)
	Bar2Frame:SetVisible(false)
	InfoFrame.lock = true
end

function Notis.CheckBoss(list, bossName, limitHP)
	list = list or Inspect.Unit.List()
	if list then
		limitHP = limitHP or 0
		for unitID in pairs(list) do
			local d = Inspect.Unit.Detail(unitID)
			if d and d.level and type(d.level) == "string" then	-- any boss level is "??" as string
				if d.name == bossName and d.combat then
					if limitHP == 0 then return(true) end
					local hp = d.health or 0
					local mx = d.healthMax or 1
					return(math.ceil(hp / mx * 100) > limitHP)
				end
			end
		end
	end
end

function Notis.Event.Notify(notify)
	if notify.message then
		local arrayedMessage = Notis.StrToArray(notify.message)

		-- sub
		local function GetMatch(emote)
			for i, v in ipairs(emote) do
				if v ~= arrayedMessage[i] and v ~= "*" then return(false) end
			end
			return(true)
		end
		-- end sub

		for _, value in ipairs(NOTIFY) do
			local text, emote, role = unpack(value)
			if GetMatch(emote) then
				if not PlayerRole then
					local pr = Inspect.Unit.Detail(PLAYERID)
					if pr and pr.role then PlayerRole = pr.role end
				end
				if role == nil or role == PlayerRole then
					Notis.Activate(text)
				end
				return
			end
		end

		for _, v in ipairs(arrayedMessage) do
			if v:gsub("%W", "") == PLAYER then
				Notis.Activate(PLAYER)
				break
			end
		end
	end
end
table.insert(Event.Chat.Notify, {Notis.Event.Notify, "Notis", "Event Notification"})

function Notis.FormatTime(taim)
	local m = math.floor(taim / 60)
	local s = math.floor(taim)% 60
	local ms = taim *60% 60
	if m > 0 then
		return(string.format("%02d\'%02d\"%02d", m, s, ms))
	else
		return(string.format("%02d\"%02d", s, ms))
	end
end

table.insert(Event.System.Update.Begin, {function()
	local now = Inspect.Time.Real()
	if (now - LastUpdate) > UPDATE then LastUpdate = now else return end

	if Info1.duration and Info1.begin then
		if Info1.duration + Info1.begin > now then
			local remaining = now - Info1.begin
			if InfoFrame.timerMode then
				Notis.SetNum(Info1.duration + Info1.begin - now)
			else
				local alpha = 1
				if remaining > DURA then
					local _, b = math.modf((remaining - DURA) / ((Info1.duration - DURA) / PULSE))
					alpha = 1 - b^2
				end
				InfoFrame:SetAlpha(alpha)
			end
		else
			Notis.Terminate()
			if Notis.CheckBoss(nil, "Jornaru", 60) then
				if InfoFrame.timerMode then
					Notis.Activate("Wave!")
				else
					Notis.Activate(TIDALWAVE_SEC - ELAPSE, "Tidal Wave")
				end
			elseif Notis.CheckBoss(nil, "Sicaron") then
				if InfoFrame.timerMode and Info1.timerBuff then
					Info1.timerBuff = nil
					Notis.Activate("Run Out")
				end
			end
		end
	end

	if Info2 then
		if (Info2.duration and Info2.begin and Info2.direction) and Info2.duration + Info2.begin > now then
			HugeBarL:SetWidth(math.ceil(UIWidth*math.abs(Info2.direction-((Info2.duration+Info2.begin-now)/Info2.duration))))
			HugeTxt1:SetText(Notis.FormatTime(Info2.duration + Info2.begin - now))
		else
			HugeFrame:SetVisible(false)
			Info2 = nil
		end
	end
end, "Notis", "UpdateBegin"})

table.insert(Event.Unit.Detail.Combat, {function(list)
	if Notis.CheckBoss(list, "Jornaru", 60) then
		Notis.Activate(TIDALWAVE_SEC, "Tidal Wave")
	elseif Notis.CheckBoss(list, "Ituziel") then
		Notis.Activate(WOI_SEC, "Word of Incineration")
	end
end, "Notis", "DetailCombat"})

local ABI = {
	["Bitter Wind"] = 1,
	["Interdict"] = 1,
	["Weapon Barrage"] = 1,
	["Deaden"] = 1,
	["Concussive Blast"] = 1,
	["Planar Disruption"] = 1,
	["Bash"] = 1,
	["Face Slam"] = 1,
	["Flinching Strike"] = 1,
	["Earth Burst"] = 1,
	["Furious Rage"] = 1,
	["Thunder Blast"] = 1,
	["Purge"] = 2,
	["Sigil of Woe"] = 2,
	["Eradicate"] = 2,
	["Spell Sunder"] = 2,
	["Consumption"] = 2,
	["Purging Flames"] = 2,
	["Degeneration"] = 2,
	["Cleansing Prayer"] = 3,
	["Cauterize"] = 3,
	["Cleansing Waters"] = 3,
	["Twilight Transcendence"] = 3,
	["Cleansing Flames"] = 3,
	["Nature's Cleansing"] = 3,
	["Deny"] = 3,
	["Spellbreaker"] = 4,
	["Purification"] = 4,
}
PcAbi = {}
table.insert(Event.Ability.New.Add, {function()	--forget API Parameters it's bugged after summon pet
	local pr = Inspect.Unit.Detail(PLAYERID)
	if pr and pr.role then PlayerRole = pr.role end

	PcAbi[1],PcAbi[2],PcAbi[3],PcAbi[4] = false, false, false, false
	local playerAbi = Inspect.Ability.New.List()
	if playerAbi then
		for j in pairs(playerAbi) do
			local d = Inspect.Ability.New.Detail(j)
			if d and ABI[d.name] then PcAbi[ABI[d.name]] = true	end
		end

		MeleeID = ""
		for j in pairs(playerAbi) do
			local d = Inspect.Ability.New.Detail(j)
			if d and d.rangeMax and d.rangeMax < 7 and d.name ~= "Toggle Auto Attack" then
				MeleeID = j
				break
			end
		end
	end
end, "Notis", "OnAbiAdd"})

function Notis.SetHuge(info, abi, txt, inc, bgColor, barColor)
	Info2 = info
	Info2.begin = Inspect.Time.Real()
	HugeAbi:SetText(abi)
	if txt then HugeTxt2:SetText(txt) else HugeTxt2:SetText("") end
	if inc then
		Info2.direction = 1
	else
		Info2.direction = 0
	end
	if bgColor then
		HugeFrame:SetBackgroundColor(unpack(bgColor))
	else
		HugeFrame:SetBackgroundColor(unpack(BLACK))
	end
	if barColor then
		HugeBarL:SetBackgroundColor(unpack(barColor))
	else
		HugeBarL:SetBackgroundColor(unpack(CYAN))
	end
	HugeFrame:SetVisible(true)
end

function Notis.GetOutOfRange()
	if MeleeID and MeleeID ~= "" then
		local d = Inspect.Ability.New.Detail(MeleeID)
		return(d.outOfRange)
	end
	return(true)
end

local CAST = {
	["Invulnerable"]			= {user="dps"},
	["Iron Wrath"]				= {text="Stack"},
	["Savage Edge"]				= {user="melee", text="Run Out"},
	["Thousand Cuts"]			= {user="melee", text="Run Out"},
	["Ember Rain"]				= {user="melee", text="Run Out"},
	["Dark Invocation"] 		= {user="interrupt"},
	["Summon Scorching Shard"]	= {text="Shard%", noHuge=true},
	["Word of Incineration"]	= {timer=WOI_SEC, noHuge=true},
	["Death Blow"]				= {user="interrupt"},
	["Molten Rejuvenation"]		= {text="Stop DPS"},
	["Fashion Similar"]			= {user="interrupt"},
	["Soul Trauma"]				= {user="interrupt"},
	["Frightening Shout"]		= {user="interrupt"},
	["Consuming Essence"]		= {user="interrupt"},
	["Runic Feedback"]			= {text="DPS Stop", noHuge=true},
	["Dark Wrath"]				= {user="melee", text="Run Out"},
	["Prince's Wrath"]			= {user="melee", text="Run Out"},
	["Vicious Tail Strike"]		= {user=PLAYERID, text="Run Out"},
	["Ice Shard"]				= {user="interrupt"},
	["Wild Cudgel"]				= {user="interrupt"},
	["Death Blast"]				= {user="interrupt"},
	["Feline Mend"]				= {user="interrupt"},
	["Cyclonic Destruction"]	= {user="melee", text="Run Out"},
	["Reflecting Torrent"]		= {text="Stop DPS"},
	["Icy Explosion"]			= {text="LoS"},
	["Jagged Ice Shield"]		= {text="Stop DPS"},
	["Wrath of Sparkwing"]		= {user="melee", text="Run Out"},
	["Boiling Marrow"]			= {text="LoS"},
	["Bone Theft"]				= {text="LoS"},
	["Flames of Ragnoth"]       = {text="Stack"},
	["Ancient Fury"]			= {user="melee", text="Run Out"},
	["Glacial Shield"]			= {text="Stop DPS"},
	["Death Rite"]				= {text="LoS"},
	["Blinding Darkness"]       = {text="Look Away"},
	["Call of the Ascended"]	= {user="ally"},
	["Summon Rescue Medic"]     = {user="ally"},
}

table.insert(Event.Unit.Castbar, {function(val)
	if not PlayerRole then
		local pr = Inspect.Unit.Detail(PLAYERID)
		if pr and pr.role then PlayerRole = pr.role end
	end
	local focus = Inspect.Unit.Lookup("focus") or "fcs"
	local pcTarget = Inspect.Unit.Lookup("player.target") or "tgt"

	for k, v in pairs(val) do
		local info = Inspect.Unit.Castbar(k) or false
		if info then
			info.unit = k
			local abiName = info.abilityName
			local kd = Inspect.Unit.Detail(k)
			if kd and kd.relation then
				if kd.relation == "hostile" then
					local target = Inspect.Unit.Lookup(k..".target")

					-- cast data collection for developer
					if Bc then
						Notis.Pr("\nCAST\ncaster: \t"..kd.name)
						Notis.Pr("target: \t"..Inspect.Unit.Detail(target).name)
						for a,b in pairs(info)do Notis.Pr(a.." \t"..tostring(b)) end
					end

					if CAST[abiName] then
						if CAST[abiName].user == nil
						or CAST[abiName].user == PlayerRole
						or CAST[abiName].user == target
						or (CAST[abiName].user == "interrupt" and PcAbi[1] and (focus == k or pcTarget == k) and not info.uninterruptible)
						or (CAST[abiName].user == "melee" and pcTarget == k and not Notis.GetOutOfRange())
						then
							if CAST[abiName].text then
								local str, n = string.gsub(CAST[abiName].text, "%%", "")
								if n > 0 then	-- "Mc%"
									tnd = Inspect.Unit.Detail(target)
									if tnd and tnd.name then
										str = str.." "..tnd.name
									end
								end
								Notis.Activate(str, abiName)
							elseif CAST[abiName].timer then
								Notis.Activate(CAST[abiName].timer, abiName)
							end
							if not CAST[abiName].noHuge then
								local c = {}
								if info.uninterruptible then
									c = YELLOW
								else
									c = AQUA
								end
								Notis.SetHuge(info, abiName, kd.name.." ", true, false, c)
							end
						end
					end
				elseif CAST[abiName] then
					Notis.SetHuge(info, abiName, kd.name.." ", true, false, false)
				end
			end
		else
			if Info2 and Info2.unit == k then
				local now = Inspect.Time.Real()
				if not Info2.uninterruptible and now-Info2.begin+.2 < Info2.duration then
					local info = {duration = HUGEDURA}
					Notis.SetHuge(info, "- Interrupted -", "", false, PINK, CLEAR)
				else
					HugeFrame:SetVisible(false)
					Info2 = nil
				end
			end
		end
	end
end, "Notis", "Castbar"})

local BUFF = {
	B1AB1097BD47BF955 = {text="Chain%", noHuge=true},
	B04039E9917464055 = {text="MC%", user="dps", noHuge=true},
	B0A050BA3AC830A93 = {user="purge"},
	B081D21E36954A65F = {user="cure"},
	B3DA21C6CF992488C = {text="Feedback", user=PLAYERID},
	B7503EEF91F80A1DF = {user=PLAYERID},
	B7FBFEE2EA31C8D3E = {user=PLAYERID},
	B2E69A76D6347A13F = {text="Run Out", user=PLAYERID},
	B54BE57ADB05B06DF = {},
	B4EB54CB2103211AA = {text="Reflect"},
	B71C603226FB5D232 = {user="purge"},
	B0D25B89AC399B495 = {timer=12, user=PLAYERID},
	B01D5722DCA4B44C3 = {user=PLAYERID},
	B26DCDAE9022CF0C3 = {text="Stack", user=PLAYERID},
	B37CD7ADD718FE15C = {text="Stop", user=PLAYERID},
	B59F93A424CB91CA8 = {text="SOUL", user=PLAYERID},
	B05940EA67C2F7CF2 = {text="Run", user=PLAYERID},
	B32738DECB348C394 = {},
	B16BF0A38C72EE69C = {text="Cure", user="cure", noHuge=true},
	B27C327C922954ACF = {text="Cure", user="cure", noHuge=true},
	B68C413F8AABA7D00 = {text="Stop"},
	B19B12E29984C5401 = {text="Stop"},
	B021E133F0B212F9D = {text="Cure", user="cure", noHuge=true},
	B21EA5575610B60E5 = {},
	B6BD353C26A138D78 = {text="Cure", user="cure", noHuge=true},
	B63D96DEC13591640 = {user="purge"},
	B58160EB978579073 = {user="purge"},
	B33C30D4AC8FE2CEE = {user="purge"},
	B36D75D8B21543725 = {user="purge"},
	B3A394067439FD083 = {user="purge"},
	B67B434753774797B = {},
	["Enraged!"]      = {text="Enraged!", noHuge=true},
	B69270855B9A593AC = {cancel="Cancel Sheep", user=PLAYERID},
	B68465D242F609512 = {user="dead"},
}

table.insert(Event.Buff.Add, {function(unit, buff)
	local buffDetail = Inspect.Buff.Detail(unit, buff)
	if not buffDetail then return end
	for id, info in pairs(buffDetail) do
		local cd = Inspect.Unit.Detail(info.caster)
		if cd and cd.relation then
			local targetName = ""
			local tnd = Inspect.Unit.Detail(unit)
			if tnd and tnd.name then
				targetName = tnd.name
			end
			if cd.relation == "hostile" then

				-- collect buff data "/notis bc" for developer
				if Bc then
					Notis.Pr("\nBUFF\ncaster: \t"..cd.name)
					Notis.Pr("target: \t"..targetName)
					for a,b in pairs(info)do Notis.Pr(a.." \t"..tostring(b)) end
				end

				-- sub
				local function BuffSub(abi)
					if not PlayerRole then
						local pr = Inspect.Unit.Detail(PLAYERID)
						if pr and pr.role then PlayerRole = pr.role end
					end
					if abi.user == nil
					or abi.user == unit
					or (abi.user == "purge" and PcAbi[2] and not (info.name == "Soul Harvest" and RavagedSoul))
					or (abi.user == "cure" and (PcAbi[3] or (info.curse and PcAbi[4])))
					or abi.user == PlayerRole
					then
						if abi.timer then
							Info1.timerBuff = id
							Notis.Activate(abi.timer, info.name)
						elseif info.name == "Ravaged Soul" then
							RavagedSoul = id
						else
							if abi.text then
								local str, n = string.gsub(abi.text, "%%", "")
								if n > 0 then
									if targetName then
										str = str.." "..targetName
									end
									Notis.Activate(str, info.name)
								else
									Notis.Activate(abi.text, info.name)
								end
							end
							local bgColor = false
							if info.curse then
								bgColor = VIOLET
							elseif info.disease then
								bgColor = GOLD
							elseif info.poison then
								bgColor = LIME
							end
							if not abi.noHuge then
								Notis.SetHuge(info, info.name, cd.name, false, bgColor, false)
							end
						end
					end
				end
				-- end sub

				if BUFF[info.name] then
					--BuffSub(BUFF[info.name])	--for full function
					Notis.Activate(BUFF[info.name].text or info.name or "")
				elseif BUFF[info.type] then
					BuffSub(BUFF[info.type])
				end
			elseif BUFF[info.type] then
				if BUFF[info.type].user == unit then
					if BUFF[info.type].cancel then
						if InCombat then
							Command.Buff.Cancel(id)
							SheepID = nil
						else
							SheepID = id
							CBButton:SetText(BUFF[info.type].cancel)
							CBButton:SetVisible(true)
						end
					end
				elseif BUFF[info.type].user == "dead" then	--ex."Soul Walk"
					local hp = Inspect.Unit.Detail(PLAYERID)
					if hp and hp.health and hp.health == 0 then
						Notis.SetHuge(info, info.name, targetName)
					end
				end
			end
		end
	end
end, "Notis", "OnBuffAdd"})

table.insert(Event.Buff.Remove, {function(unit, buff)
	for k, v in pairs(buff) do
		if Info2 and Info2.id == k then
			local now = Inspect.Time.Real()
			if Info2.begin and Info2.duration and now-Info2.begin+.2 < Info2.duration then
				local info = {duration = HUGEDURA}
				Notis.SetHuge(info, "- Purged -", "", false, PINK, CLEAR)
			else
				Info2 = nil
				HugeFrame:SetVisible(false)
			end
		end
		if SheepID and SheepID == k then
			if CBButton:GetVisible() then CBButton:SetVisible(false) end
			SheepID = nil
		end
		if Info1.timerBuff and Info1.timerBuff == k then
			Info1.timerBuff = nil
			Notis.Terminate()
		end
		if RavagedSoul and RavagedSoul == k then
			RavagedSoul = nil
		end
	end
end, "Notis", "OnBuffRemove"})

table.insert(Event.System.Secure.Enter, {function()
	InCombat = true
	if SheepID then
		if CBButton:GetVisible() then CBButton:SetVisible(false) end
		local id = SheepID
		SheepID = nil
		Command.Buff.Cancel(id)
		Notis.Pr("Addon was take off Sheep's clothing couse your in combat.")
	end
end, "Notis", "OnSecureEnter"})

table.insert(Event.System.Secure.Leave, {function()
	InCombat = false
	Notis.Terminate()
	Info2 = nil
	HugeFrame:SetVisible(false)
end, "Notis", "OnSecureLeave"})

table.insert(Event.Combat.Death, {function()
	if Info2 and Info2.unit then
		local h = Inspect.Unit.Detail(Info2.unit)
		if h and h.health == 0 then
			local info = {duration = HUGEDURA}
			Notis.SetHuge(info, "- Defeated -", "", false, BLACK, CLEAR)
		end
	end
	local d = Inspect.Unit.Detail(PLAYERID)
	if not d or not d.health or d.health == 0 then
		Notis.Terminate()
	end
end, "Notis", "OnDeath"})

table.insert(Event.Addon.Load.End, {function(addon)
	if addon == "Notis" then
		Notis.Context = UI.CreateContext("Notis")

		CBButton = UI.CreateFrame("RiftButton", "CancelBuffButton", Notis.Context)
		CBButton:SetPoint(.5,0, UIParent, .5,0)
		CBButton:SetHeight(42)
		CBButton:SetWidth(200)
		CBButton:SetVisible(false)
		function CBButton.Event:LeftPress()
			CBButton:SetVisible(false)
			if SheepID then
				Command.Buff.Cancel(SheepID)
				SheepID = nil
			end
		end

		-- HugeBar
		HugeFrame = UI.CreateFrame("Frame", "HugeFrame", Notis.Context)
		HugeFrame:SetPoint(0,.5, UIParent, 0,.5)
		HugeFrame:SetPoint(1,.5, UIParent, 1,.5, 0,NotisSettings.hugeBarTop)
		HugeFrame:SetHeight(NotisSettings.hugeBarHeight)
		HugeFrame:SetAlpha(NotisSettings.hugeBarAlpha)
		HugeFrame:SetVisible(false)

		HugeBarL = UI.CreateFrame("Frame", "HugeBarL", HugeFrame)
		HugeBarL:SetPoint(0,.5, HugeFrame, 0,.5)
		HugeBarL:SetHeight(math.ceil(NotisSettings.hugeBarHeight*.9))
		HugeBarL:SetAlpha(.75)
		HugeBarL:SetLayer(1)

		HugeAbi = UI.CreateFrame("Text", "HugeAbi", HugeFrame)
		HugeAbi:SetPoint(.5,.5, HugeFrame, .5,.5)
		HugeAbi:SetLayer(3)
		HugeAbi:SetFontSize(math.ceil(NotisSettings.hugeBarHeight*.7))

		HugeTxt1 = UI.CreateFrame("Text", "HugeText", HugeFrame)
		HugeTxt1:SetPoint(0,.5, HugeFrame, 0,.5)
		HugeTxt1:SetLayer(3)
		HugeTxt1:SetFontSize(math.ceil(NotisSettings.hugeBarHeight*.7))

		HugeTxt2 = UI.CreateFrame("Text", "HugeText", HugeFrame)
		HugeTxt2:SetPoint(1,.5, HugeFrame, .99,.5)
		HugeTxt2:SetLayer(3)
		HugeTxt2:SetFontSize(math.ceil(NotisSettings.hugeBarHeight*.5))

		-- RedBar
		Bar1Frame = UI.CreateFrame("Texture", "Bar1Frame", Notis.Context)
		Bar1Frame:SetPoint(0,0, UIParent, 0,0)
		Bar1Frame:SetPoint(1,0, UIParent, 1,0, 0, NotisSettings.redBartop)
		Bar1Frame:SetLayer(0)
		Bar1Frame:SetHeight(16)
		Bar1Frame:SetTexture("Notis", "redu.png")
		Bar1Frame:SetVisible(false)

		Bar2Frame = UI.CreateFrame("Texture", "Bar2Frame", Notis.Context)
		Bar2Frame:SetPoint(0,1, UIParent, 0,1)
		Bar2Frame:SetPoint(1,1, UIParent, 1,1, 0, -NotisSettings.redBartop)
		Bar2Frame:SetLayer(0)
		Bar2Frame:SetHeight(16)
		Bar2Frame:SetTexture("Notis", "redl.png")
		Bar2Frame:SetVisible(false)

		-- Infomation
		InfoFrame = UI.CreateFrame("Frame", "NotisFrame", Notis.Context)
		InfoFrame:SetPoint(0,0, UIParent, 0,0, NotisSettings.x, NotisSettings.y)
		InfoFrame:SetLayer(0)
		InfoFrame:SetWidth(160)
		InfoFrame:SetHeight(80)
		InfoFrame:SetVisible(false)
		InfoFrame.lock = true
		InfoFrame.timerMode = false

		InfoTxt = UI.CreateFrame("Text", "InfoText", InfoFrame)
		InfoTxt:SetPoint(0,0, InfoFrame, 0,0)
		InfoTxt:SetLayer(2)
		InfoTxt:SetFontSize(NotisSettings.fontSize)

		function InfoTxt.Event:LeftDown()
			if InfoFrame.lock == false then
				InfoFrame.mouseDown = true
				local mouse = Inspect.Mouse()
				InfoFrame.startX = InfoFrame:GetLeft()
				InfoFrame.startY = InfoFrame:GetTop()
				InfoFrame.mouseStartX = mouse.x
				InfoFrame.mouseStartY = mouse.y
			end
		end

		function InfoTxt.Event:MouseMove()
			if InfoFrame.mouseDown and InfoFrame.lock == false then
				local mouse = Inspect.Mouse()
				NotisSettings.x = mouse.x - InfoFrame.mouseStartX + InfoFrame.startX
				NotisSettings.y = mouse.y - InfoFrame.mouseStartY + InfoFrame.startY
				InfoFrame:SetPoint(0,0, UIParent, 0,0, NotisSettings.x, NotisSettings.y)
			end
		end

		function InfoTxt.Event:LeftUp()
			if InfoFrame.mouseDown then
				InfoFrame.mouseDown = false
			end
		end

		function InfoTxt.Event:RightClick()
			if InfoFrame.lock == false then
				Notis.Terminate()
			end
		end

		InfoSdw = UI.CreateFrame("Text", "InfoShadow", InfoFrame)
		InfoSdw:SetPoint(.5,.5, InfoTxt, .5,.5, 2, 1)
		InfoSdw:SetLayer(1)
		InfoSdw:SetFontColor(0, 0, 0, 1)
		InfoSdw:SetFontSize(NotisSettings.fontSize)

		InfoSec = UI.CreateFrame("Text", "InfoTextSecond", InfoFrame)
		InfoSec:SetPoint(0,.185, InfoTxt, 1,.815, -6, -18)
		InfoSec:SetLayer(4)
		InfoSec:SetFontColor(1, 1, 1, 1)
		InfoSec:SetFontSize(20)

		InfoScw = UI.CreateFrame("Text", "InfoTextSecondShadow", InfoFrame)
		InfoScw:SetPoint(.5,.5, InfoSec, .5,.5, 2, 1)
		InfoScw:SetLayer(3)
		InfoScw:SetFontColor(0, 0, 0, 1)
		InfoScw:SetFontSize(20)

		AbiTxt = UI.CreateFrame("Text", "InfoText", InfoFrame)
		AbiTxt:SetPoint(1,.82, InfoTxt, 0,.18, 0, 32)
		AbiTxt:SetFontSize(15)
		AbiTxt:SetLayer(4)
		AbiTxt:SetFontColor(.9,.75,.6,1)

		AbiSdw = UI.CreateFrame("Text", "InfoShadow", InfoFrame)
		AbiSdw:SetPoint(.5,.5, AbiTxt, .5,.5, 2, 1)
		AbiSdw:SetFontSize(15)
		AbiSdw:SetLayer(3)
		AbiSdw:SetFontColor(0, 0, 0, .5)

		Notis.Pr(VER, "combat")
	end
end, "Notis", "InititalSetup"})

table.insert(Command.Slash.Register("notis"), {function(cmd)

	-- sub
	local function ArrayToStr(a)
		local str = ""
		for _, v in pairs(a) do
			str = str.." "..v
		end
		return(str)
	end

	local function HugeBarTest(sec)
		local info = {
			begin = Inspect.Time.Real(),
			duration = sec or 3,
		}
		local abi = "Huge bar Test"
		local txt = "Notis"
		Notis.SetHuge(info, abi, txt)
	end
	-- end sub

	local arg = {}
	local i = 1
	for v in string.gmatch(cmd, "[^%s]+") do
		arg[i] = v:lower()
		i = i + 1
	end

	cmd = cmd:lower()
	local i = tonumber(cmd) or 0
	if arg[1] == "set" then
		Notis.Activate(25, "Set RightClick", .5)
		InfoFrame.lock = false
		return
	elseif arg[1] == "reset" then
		InfoFrame.lock = true
		NotisSettings.x = 120
		NotisSettings.y = 160
		NotisSettings.fontSize = 60
		Notis.Activate(2, "Notis position is Reset")

		NotisSettings.redBartop = -6
		Bar1Frame:SetPoint(0,0, UIParent, 0,0, 0, NotisSettings.redBartop)
		Bar2Frame:SetPoint(0,1, UIParent, 0,1, 0, -NotisSettings.redBartop)

		NotisSettings.hugeBarHeight = 52
		NotisSettings.hugeBarTop = 100
		HugeFrame:SetHeight(NotisSettings.hugeBarHeight)
		HugeBarL:SetHeight(math.ceil(NotisSettings.hugeBarHeight*.9))
		HugeAbi:SetFontSize(math.ceil(NotisSettings.hugeBarHeight*.7))
		HugeTxt1:SetFontSize(math.ceil(NotisSettings.hugeBarHeight*.7))
		HugeTxt2:SetFontSize(math.ceil(NotisSettings.hugeBarHeight*.5))
		NotisSettings.hugeBarAlpha = .2
		HugeFrame:SetAlpha(NotisSettings.hugeBarAlpha)
		HugeBarTest()
		return
	elseif arg[1] == "a" then
		local str = "Vritra called to "..PLAYER.."!"
		Notis.Event.Notify({message = str})
		return
	elseif i > 0 and i <= #NOTIFY then
		local str = ArrayToStr(NOTIFY[i][2])
		Notis.Event.Notify({message = str})
		Notis.Pr("Test "..cmd..": "..str)
		return
	elseif arg[1] == "emotelist" then
		for i = 1, #NOTIFY do
			Notis.Pr(i.." \t"..ArrayToStr(NOTIFY[i][2]))
		end
		return
	elseif arg[1] == "abilist" then
		for k, v in pairs(ABI) do
			local a = ""
			if     v == 1 then a = "Interrupter"
			elseif v == 2 then a = "Purger"
			elseif v == 3 then a = "Curer"
			elseif v == 4 then a = "Spellbreaker"
			end
			Notis.Pr(k.." ("..tostring(a)..")")
		end
		return
	elseif arg[1] == "castlist" then
		for k, v in pairs(CAST) do
			local str = k
			for a, b in pairs(v) do
				str = str.."   "..tostring(a).."=\""..tostring(b).."\""
			end
			Notis.Pr(str)
		end
		return
	elseif arg[1] == "bufflist" then
		for k, v in pairs(BUFF) do
			local str = k
			for a, b in pairs(v) do
				str = str.."   "..tostring(a).."=\""..tostring(b).."\""
			end
			Notis.Pr(str)
		end
		return
	elseif arg[1] == "cs" then
		Notis.Pr("Interrupter = ".." \t"..tostring(PcAbi[1]))
		Notis.Pr("Purger = ".." \t"..tostring(PcAbi[2]))
		Notis.Pr("Curer = ".." \t"..tostring(PcAbi[3]))
		Notis.Pr("Spellbreaker = ".." \t"..tostring(PcAbi[4]))
		Notis.Pr("MeleeID = ".." \t"..tostring(MeleeID))
		return
	elseif arg[1] == "huge" then
		local sec = 3
		if tonumber(arg[2]) then sec = tonumber(arg[2]) end
		HugeBarTest(sec)
		return
	elseif arg[1] == "redbartop" or arg[1] == "redt" then
		if tonumber(arg[2]) then
			NotisSettings.redBartop = math.ceil(tonumber(arg[2]))
			Bar1Frame:SetPoint(0,0, UIParent, 0,0, 0, NotisSettings.redBartop)
			Bar2Frame:SetPoint(0,1, UIParent, 0,1, 0, -NotisSettings.redBartop)
		else
			Notis.Pr("RedBarTop".." \t"..tostring(NotisSettings.redBartop))
		end
		Notis.Event.Notify({message = PLAYER})
		return
	elseif arg[1] == "hugebartop" or arg[1] == "huget" then
		if tonumber(arg[2]) then
			NotisSettings.hugeBarTop = math.ceil(tonumber(arg[2]))
			HugeFrame:SetPoint(0,.5, UIParent, 0,.5, 0, NotisSettings.hugeBarTop)
		else
			Notis.Pr("HugeBarTop".." \t"..tostring(NotisSettings.hugeBarTop))
		end
		HugeBarTest()
		return
	elseif arg[1] == "hugebarheight" or arg[1] == "hugeh" then
		if tonumber(arg[2]) then
			NotisSettings.hugeBarHeight = math.ceil(tonumber(arg[2]))
			HugeFrame:SetHeight(NotisSettings.hugeBarHeight)
			HugeBarL:SetHeight(math.ceil(NotisSettings.hugeBarHeight*.9))
			HugeAbi:SetFontSize(math.ceil(NotisSettings.hugeBarHeight*.7))
			HugeTxt1:SetFontSize(math.ceil(NotisSettings.hugeBarHeight*.7))
			HugeTxt2:SetFontSize(math.ceil(NotisSettings.hugeBarHeight*.5))
		else
			Notis.Pr("HugeBarHeight".." \t"..tostring(NotisSettings.hugeBarHeight))
		end
		HugeBarTest()
		return
	elseif arg[1] == "hugealpha" or arg[1] == "hugea" then
		if tonumber(arg[2]) then
			NotisSettings.hugeBarAlpha = tonumber(arg[2])
			HugeFrame:SetAlpha(NotisSettings.hugeBarAlpha)
		else
			Notis.Pr("HugeBarAlpha".." \t"..tostring(NotisSettings.hugeBarAlpha))
		end
		HugeBarTest()
		return
	elseif arg[1] == "stacknumber" or arg[1] == "stack" then
		if tonumber(arg[2]) then
			StackNumber = math.min(math.ceil(tonumber(arg[2])), 9)
		else
			Notis.Pr("/notis stacknumber|stack 1..9. 0 is clear.")
		end
		if StackNumber == nil then return end

		if StackNumber < 1 then StackNumber = nil; return end
		Notis.Event.Notify({message = "You'll never escape!"})
		Notis.Pr("Stack Number Test ("..tostring(StackNumber)..")")
		return
	elseif arg[1] == "fontsize" or arg[1] == "f" then
		if tonumber(arg[2]) then
			NotisSettings.fontSize = tonumber(arg[2])
			NotisSettings.fontSize = math.max(NotisSettings.fontSize, 20)
			NotisSettings.fontSize = math.min(NotisSettings.fontSize, 125)
			InfoTxt:SetFontSize(NotisSettings.fontSize)
			InfoSdw:SetFontSize(NotisSettings.fontSize)
			Notis.Activate(10, "Set fontsize="..tostring(NotisSettings.fontSize))
		else
			Notis.Pr("Font Size \t"..tostring(NotisSettings.fontSize)..". \tMax125, Min20.")
		end
		return
	elseif arg[1] == "bc" then
		if Bc then
			Bc = false
		else
			Bc = true
		end
		Notis.Pr("Buff Collect \t"..tostring(Bc))
		return
	end
	Notis.Pr("/notis set|reset|1.."..tostring(#NOTIFY).."|redt #|huget #|hugeh #|hugea #|stack #|f #.")
end, "Notis", "Slash Command"})
